#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <algorithm>
#include <cmath>
#include <map>
#include<time.h>
#define ll long long
using namespace std;

int const D=101,I=101,N=100001,L=21,Threashold=40;
int n,d,k,J,p[N],now=1,q[D],coreset[N],T;
ll rv[N][D],RawData[N][D],innp[N][I][L],b[D];
double s[N],pre_sum[N],weight[N];
map <ll, int> m[I][L];
map <ll, int> :: iterator pp;
bool family[I][D],used[N],check[N][I];
std::default_random_engine e;
std::normal_distribution<double> dist; 
typedef pair <double, int> Pair;

ll cabs(ll x){
	if (x<0) return -x; else return x;
}

ll distance(int i, int j){
	ll dis=1e9;
	for (int t=1;t<=q[0];t++){
		ll r=0;
		for (int l=1;l<=d;l++)
			if (family[i][l]) r+=(RawData[q[t]][l]-RawData[j][l])*(RawData[q[t]][l]-RawData[j][l]);
		if (r<dis) dis=r;
	}
	return dis;
}

ll distob(ll v){
	ll dis=1e9;
	for (int i=1;i<=q[0];i++)
		if (cabs(b[i]-v)<dis) dis=cabs(b[i]-v);
	return dis; 
}


int Furthest(int i, int l){
	if (m[i][l].empty()) return 0;
	for (int j=1;j<=q[0];j++)
		b[j]=innp[q[j]][i][l];
	pp=m[i][l].begin();
	int ans=pp->second; ll ansv=pp->first;
	pp=m[i][l].end();
	pp--;
	if (distob(pp->first)>distob(ansv)){
		ans=pp->second;
		ansv=pp->first;
	}
	if (q[0]==1) return ans;
	
	sort(b+1,b+q[0]+1);
	
	for (int j=1;j<q[0];j++){
		double r=(b[j]+b[j+1])/2;
		pp=m[i][l].lower_bound(r);
		if (distob(pp->first)>distob(ansv)){
			ans=pp->second;
			ansv=pp->first;
		}
		pp=m[i][l].upper_bound(r);
		if (pp!=m[i][l].end() && distob(pp->first)>distob(ansv)) {
			ans=pp->second;
			ansv=pp->first;
		}	
	}
	return ans;
}

void Gen_family(){
	for (int i=1;i<I;i++)
		for (int j=1;j<=d;j++){
			int r=rand()%(k+J);
			if (r<J) family[i][j]=1; else family[i][j]=0;
		}
}

void Init(){
	srand((int)time(0));
	cin>>n>>d>>k>>J;
	for (int i=1;i<=n;i++)
		for (int j=1;j<=d;j++)
			cin>>RawData[i][j];
	
	Gen_family();
	for (int i=1;i<L;i++)
		for (int j=1;j<=d;j++)
			rv[i][j]=1.0*(rand()%10);
			
	for (int i=1;i<=n;i++)
		for (int j=1;j<I;j++){
			check[i][j]=true;
			for (int t=1;t<=d;t++)
				if (family[j][t] && RawData[i][t]==-1) check[i][j]=false;
		}
	for (int i=1;i<=n;i++)
		for (int j=1;j<I;j++)
			if (check[i][j])
				for (int t=1;t<L;t++){
					innp[i][j][t]=0;
					for (int l=1;l<=d;l++)
						if (family[j][l]) innp[i][j][t]+=RawData[i][l]*rv[t][l];
					innp[i][j][t]=innp[i][j][t]*n+i;
					m[j][t].insert(Pair (innp[i][j][t],i));
				}
}

int get_next(int i){
	while (used[i]) i++;
	return i;
}
 
void LinfCoreset(){
	for (int i=1;i<I;i++){
		now=get_next(now);
		q[0]=1;
		q[1]=now;
		for (int j=2;j<=k+1;j++){
			q[0]=j;
			q[j]=0;
			for (int t=1;t<L;t++){
				int x=Furthest(i,t);
				if (!x) continue;
				if (!q[j]) q[j]=x; else{
					double dis=distance(i,x);
					if (dis>distance(i,q[j])) q[j]=x;
				}
			}
		}
		for (int j=1;j<=q[0];j++) p[++p[0]]=q[j];
	}
}

int main(){
	freopen("mushroom.txt","r",stdin); 
	freopen("sensitivity.in","w",stdout);

	Init();
	
	T=n;
	double round=0; 
	while (T>0){
		round=round+1;
		p[0]=0;
		LinfCoreset();
		for (int i=1;i<=p[0];i++)
			if (!used[p[i]]){
				T--;
				used[p[i]]=true;
				s[p[i]]=1.0/round;
				for (int j=1;j<I;j++)
					if (check[p[i]][j]) 
					for (int t=1;t<L;t++){
						ll key=innp[p[i]][j][t];
						pp=m[j][t].find(key);
						if (pp!=m[j][t].end()) m[j][t].erase(pp);
					}
			}
		if (T<=Threashold){
			for (int i=1;i<=n;i++)
				if (!used[i]) s[i]=1.0/(round+1);
			break;
		}
	}
	
	cout<<n<<endl;
	for (int i=1;i<=n;i++)
		cout<<s[i]<<endl;
	
	return 0;
}
